/**** Bibliotheque graphique (definitions) ****/

/** Constantes **/

#define COULEUR_BLANC	0
#define COULEUR_NOIR	1
#define COULEUR_ROUGE	2
#define COULEUR_VERT	3
#define COULEUR_BLEU	4
#define COULEUR_ROSE	5
#define COULEUR_GRIS	6

#define MAX_LUTINS	16

/** Prototypes **/

unsigned char creerSurface(int largeur,int hauteur,char *titre);
unsigned char chargerSurface(char *fichier);
int sauverSurface(char *fichier);
void majSurface(void);
void fermerSurface(void);

void rectanglePlein(int x,int y,int l,int h,int c);
int couleurPixel(int x,int y);

int chargerLutin(char *fichier,int couleur);
void afficherLutin(int lutin,int x,int y);
int creerLutin(int x,int y,int largeur,int hauteur,int couleur);
int sauverLutin(int lutin,char *nom);
void tailleLutin(int lutin,int *largeur,int *hauteur);

unsigned char lireTouche(unsigned char *bas,char *touche,void **detail);
void attendreEvenement(void);
